Index: interface.dd
===================================================================
--- interface.dd	(revision 1638)
+++ interface.dd	(working copy)
@@ -2,19 +2,10 @@
 
 $(SPEC_S Interfaces,
 
-$(GRAMMAR
-$(GNAME InterfaceDeclaration):
-	$(B interface) $(I Identifier) $(BaseInterfaceList) $(I InterfaceBody)
-	$(LINK2 template.html#InterfaceTemplateDeclaration, $(I InterfaceTemplateDeclaration))
+$(InterfaceDeclaration_production)
+$(BaseInterfaceList_production)
+$(InterfaceBody_production)
 
-$(GNAME BaseInterfaceList):
-	$(I Empty)
-	$(B :) $(LINK2 class.html#InterfaceClasses, $(I InterfaceClasses))
-
-$(GNAME InterfaceBody):
-	$(B {) DeclDefs $(B })
-)
-
 	$(P Interfaces describe a list of functions that a class that inherits
 	from the interface must implement.
 	A class that implements an interface can be converted to a reference
Index: module.dd
===================================================================
--- module.dd	(revision 1638)
+++ module.dd	(working copy)
@@ -2,41 +2,11 @@
 
 $(SPEC_S Modules,
 
-$(GRAMMAR
-$(GNAME Module):
-	$(GLINK ModuleDeclaration) $(GLINK DeclDefs)
-	$(GLINK DeclDefs)
+$(Module_production)
+$(DeclDefs_production)
+$(DeclDef_production)
 
-$(GNAME DeclDefs):
-	$(I DeclDef)
-	$(I DeclDef) $(I DeclDefs)
 
-$(GNAME DeclDef):
-	$(LINK2 attribute.html#AttributeSpecifier, $(I AttributeSpecifier))
-	$(GLINK ImportDeclaration)
-	$(I EnumDeclaration)
-	$(I ClassDeclaration)
-	$(I InterfaceDeclaration)
-	$(I AggregateDeclaration)
-	$(I Declaration)
-	$(I Constructor)
-	$(I Destructor)
-	$(I Invariant)
-	$(I UnitTest)
-	$(I StaticConstructor)
-	$(I StaticDestructor)
-$(V2
-	$(I SharedStaticConstructor)
-	$(I SharedStaticDestructor)
-)	$(LINK2 version.html#ConditionalDeclaration, $(I ConditionalDeclaration))
-	$(LINK2 version.html#StaticAssert, $(I StaticAssert))
-	$(LINK2 template.html#TemplateDeclaration, $(I TemplateDeclaration))
-	$(LINK2 template-mixin.html#TemplateMixin, $(I TemplateMixin))
-	$(GLINK MixinDeclaration)
-	$(B ;)
-)
-
-
 	$(P Modules have a one-to-one correspondence with source files.
 	The module name is the file name with the path and extension
 	stripped off.
@@ -87,25 +57,12 @@
 	same name (stripped of path and extension) of the source file name.
 	)
 
-$(GRAMMAR
-$(GNAME ModuleDeclaration):
-	$(B module) $(I ModuleFullyQualifiedName) $(B ;)
+$(ModuleDeclaration_production)
+$(ModuleFullyQualifiedName_production)
+$(ModuleName_production)
+$(Packages_production)
+$(PackageName_production)
 
-$(GNAME ModuleFullyQualifiedName):
-	$(I ModuleName)
-	$(I Packages) $(B .) $(I ModuleName)
-
-$(GNAME ModuleName):
-	$(I Identifier)
-
-$(GNAME Packages):
-	$(I PackageName)
-	$(I Packages) $(B .) $(I PackageName)
-
-$(GNAME PackageName):
-	$(I Identifier)
-)
-
 	$(P The $(I Identifiers) preceding the rightmost are the $(I Packages)
 	that the module is in. The packages correspond to directory names in
 	the source file path.
@@ -137,35 +94,14 @@
 	by using the $(I ImportDeclaration):
 	)
 
-$(GRAMMAR
-$(GNAME ImportDeclaration):
-	$(B import) $(I ImportList) $(B ;)
-	$(B static import) $(I ImportList) $(B ;)
+$(ImportDeclaration_production)
+$(ImportList_production)
+$(Import_production)
+$(ImportBindings_production)
+$(ImportBindList_production)
+$(ImportBind_production)
+$(ModuleAliasIdentifier_production)
 
-$(GNAME ImportList):
-	$(I Import)
-	$(I ImportBindings)
-	$(I Import) $(B ,) $(I ImportList)
-
-$(GNAME Import):
-	$(I ModuleFullyQualifiedName)
-	$(I ModuleAliasIdentifier) $(B =) $(I ModuleFullyQualifiedName)
-
-$(GNAME ImportBindings):
-	$(I Import) $(B :) $(I ImportBindList)
-
-$(GNAME ImportBindList):
-	$(I ImportBind)
-	$(I ImportBind) $(B ,) $(I ImportBindList)
-
-$(GNAME ImportBind):
-	$(I Identifier)
-	$(I Identifier) = $(I Identifier)
-
-$(GNAME ModuleAliasIdentifier):
-	$(I Identifier)
-)
-
 	$(P There are several forms of the $(I ImportDeclaration),
 	from generalized to fine-grained importing.)
 
@@ -451,10 +387,7 @@
 
 <h2>$(LNAME2 MixinDeclaration, Mixin Declaration)</h2>
 
-$(GRAMMAR
-$(GNAME MixinDeclaration):
-    $(B mixin) $(B $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN)) $(B ;)
-)
+$(MixinDeclaration_production)
 
 	$(P The $(ASSIGNEXPRESSION)
 	must evaluate at compile time
Index: pragma.dd
===================================================================
--- pragma.dd	(revision 1638)
+++ pragma.dd	(working copy)
@@ -2,11 +2,7 @@
 
 $(SPEC_S Pragmas,
 
-$(GRAMMAR
-$(GNAME Pragma):
-    $(B pragma) $(B $(LPAREN)) $(I Identifier) $(B $(RPAREN))
-    $(B pragma) $(B $(LPAREN)) $(I Identifier) $(B ,) $(LINK2 expression.html#ArgumentList, $(I ArgumentList)) $(B $(RPAREN))
-)
+$(Pragma_production)
 
 
 	$(P Pragmas are a way to pass special information to the compiler
Index: statement.dd
===================================================================
--- statement.dd	(revision 1638)
+++ statement.dd	(working copy)
@@ -5,65 +5,15 @@
 C and C++ programmers will find the D statements very familiar, with a few
 interesting additions.
 
-$(GRAMMAR
-$(GNAME Statement):
-    $(B ;)
-    $(GLINK NonEmptyStatement)
-    $(GLINK ScopeBlockStatement)
+$(Statement_production)
+$(NoScopeNonEmptyStatement_production)
+$(NoScopeStatement_production)
+$(NonEmptyOrScopeBlockStatement_production)
+$(NonEmptyStatement_production)
 
-$(GNAME NoScopeNonEmptyStatement):
-    $(GLINK NonEmptyStatement)
-    $(GLINK BlockStatement)
-
-$(GNAME NoScopeStatement):
-    $(B ;)
-    $(GLINK NonEmptyStatement)
-    $(GLINK BlockStatement)
-
-$(GNAME NonEmptyOrScopeBlockStatement):
-    $(GLINK NonEmptyStatement)
-    $(GLINK ScopeBlockStatement)
-
-$(GNAME NonEmptyStatement):
-    $(GLINK LabeledStatement)
-    $(GLINK ExpressionStatement)
-    $(GLINK DeclarationStatement)
-    $(GLINK IfStatement)
-    $(GLINK WhileStatement)
-    $(GLINK DoStatement)
-    $(GLINK ForStatement)
-    $(GLINK ForeachStatement)
-    $(GLINK SwitchStatement)
-$(V2      $(GLINK FinalSwitchStatement)
-)    $(GLINK CaseStatement)
-$(V2      $(GLINK CaseRangeStatement)
-)    $(GLINK DefaultStatement)
-    $(GLINK ContinueStatement)
-    $(GLINK BreakStatement)
-    $(GLINK ReturnStatement)
-    $(GLINK GotoStatement)
-    $(GLINK WithStatement)
-    $(GLINK SynchronizedStatement)
-    $(GLINK TryStatement)
-    $(GLINK ScopeGuardStatement)
-    $(GLINK ThrowStatement)
-$(V1    $(GLINK VolatileStatement)
-)    $(GLINK AsmStatement)
-    $(GLINK PragmaStatement)
-    $(GLINK MixinStatement)
-$(V2      $(GLINK ForeachRangeStatement))
-    $(LINK2 version.html#ConditionalStatement, $(I ConditionalStatement))
-    $(LINK2 version.html#StaticAssert, $(I StaticAssert))
-    $(LINK2 template-mixin.html#TemplateMixin, $(I TemplateMixin))
-)
-
 <h2>$(LNAME2 ScopeStatement, Scope Statements)</h2>
 
-$(GRAMMAR
-$(I ScopeStatement):
-    $(GLINK NonEmptyStatement)
-    $(GLINK BlockStatement)
-)
+$(ScopeStatement_production)
 
 	$(P A new scope for local symbols
 	is introduced for the $(I NonEmptyStatement)
@@ -108,10 +58,7 @@
 
 <h2>$(LNAME2 ScopeBlockStatement, Scope Block Statements)</h2>
 
-$(GRAMMAR
-$(I ScopeBlockStatement):
-    $(GLINK BlockStatement)
-)
+$(ScopeBlockStatement_production)
 
 	$(P A scope block statement introduces a new scope for the
 	$(GLINK BlockStatement).
@@ -123,10 +70,7 @@
 	precedes a statement.
 )
 
-$(GRAMMAR
-$(I LabeledStatement):
-    $(I Identifier) : $(PSSEMI)
-)
+$(LabeledStatement_production)
 
 $(P
 	Any statement can be labeled, including empty statements,
@@ -145,26 +89,16 @@
 
 <h2>$(LNAME2 BlockStatement, Block Statement)</h2>
 
-$(GRAMMAR
-$(I BlockStatement):
-    $(B { })
-    $(B {) $(I StatementList) $(B })
+$(BlockStatement_production)
+$(StatementList_production)
 
-$(GNAME StatementList):
-    $(PSSEMI_PSCURLYSCOPE)
-    $(PSSEMI_PSCURLYSCOPE) $(I StatementList)
-)
-
 $(P
 	A block statement is a sequence of statements enclosed
 	by { }. The statements are executed in lexical order.
 )
 <h2>$(LNAME2 ExpressionStatement, Expression Statement)</h2>
 
-$(GRAMMAR
-$(I ExpressionStatement):
-    $(EXPRESSION) $(B ;)
-)
+$(ExpressionStatement_production)
 
 	The expression is evaluated.
 	<p>
@@ -187,10 +121,7 @@
 
 	Declaration statements declare variables and types.
 
-$(GRAMMAR
-$(I DeclarationStatement):
-    $(I Declaration)
-)
+$(DeclarationStatement_production)
 
 	$(P Some declaration statements:)
 
@@ -204,23 +135,11 @@
 
 	If statements provide simple conditional execution of statements.
 
-$(GRAMMAR
-$(I IfStatement):
-	$(B if $(LPAREN)) $(I IfCondition) $(B $(RPAREN)) $(I ThenStatement)
-	$(B if $(LPAREN)) $(I IfCondition) $(B $(RPAREN)) $(I ThenStatement) $(B else) $(I ElseStatement)
+$(IfStatement_production)
+$(IfCondition_production)
+$(ThenStatement_production)
+$(ElseStatement_production)
 
-$(GNAME IfCondition):
-	$(EXPRESSION)
-	$(B auto) $(I Identifier) $(B =) $(EXPRESSION)
-	$(I Declarator) $(B =) $(EXPRESSION)
-
-$(GNAME ThenStatement):
-	$(PSSCOPE)
-
-$(GNAME ElseStatement):
-	$(PSSCOPE)
-)
-
 	$(EXPRESSION) is evaluated and must have a type that
 	can be converted to a boolean. If it's true the
 	$(I ThenStatement) is transferred to, else the $(I ElseStatement)
@@ -264,10 +183,7 @@
 
 <h2>$(LNAME2 WhileStatement, While Statement)</h2>
 
-$(GRAMMAR
-$(I WhileStatement):
-    $(B while $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
-)
+$(WhileStatement_production)
 
 	While statements implement simple loops.
 
@@ -293,10 +209,7 @@
 
 <h2>$(LNAME2 DoStatement, Do Statement)</h2>
 
-$(GRAMMAR
-$(I DoStatement):
-    $(B do) $(PSSCOPE) $(B  while $(LPAREN)) $(EXPRESSION) $(B $(RPAREN))
-)
+$(DoStatement_production)
 
 	Do while statements implement simple loops.
 
@@ -324,23 +237,11 @@
 	For statements implement loops with initialization,
 	test, and increment clauses.
 
-$(GRAMMAR
-$(I ForStatement):
-	$(B for $(LPAREN))$(I Initialize) $(I Test) $(B ;) $(I Increment)$(B $(RPAREN)) $(PSSCOPE)
+$(ForStatement_production)
+$(Initialize_production)
+$(Test_production)
+$(Increment_production)
 
-$(GNAME Initialize):
-	$(B ;)
-	$(PS0)
-
-$(GNAME Test):
-	$(I empty)
-	$(EXPRESSION)
-
-$(GNAME Increment):
-	$(I empty)
-	$(EXPRESSION)
-)
-
 	$(P $(I Initialize) is executed.
 	$(I Test) is evaluated and must have a type that
 	can be converted to a boolean. If it's true the
@@ -397,28 +298,12 @@
 
 	A foreach statement loops over the contents of an aggregate.
 
-$(GRAMMAR
-$(I ForeachStatement):
-    $(I Foreach) $(B $(LPAREN))$(I ForeachTypeList) $(B ;) $(I Aggregate)$(B $(RPAREN)) $(PS0)
+$(ForeachStatement_production)
+$(Foreach_production)
+$(ForeachTypeList_production)
+$(ForeachType_production)
+$(Aggregate_production)
 
-$(GNAME Foreach):
-    $(B foreach)
-    $(B foreach_reverse)
-
-$(GNAME ForeachTypeList):
-    $(I ForeachType)
-    $(I ForeachType) , $(I ForeachTypeList)
-
-$(GNAME ForeachType):
-    $(B ref) $(I Type) $(I Identifier)
-    $(I Type) $(I Identifier)
-    $(B ref) $(I Identifier)
-    $(I Identifier)
-
-$(GNAME Aggregate):
-    $(EXPRESSION)
-)
-
 $(P
 	$(I Aggregate) is evaluated. It must evaluate to an expression
 	of type static array, dynamic array, associative array,
@@ -802,26 +687,13 @@
 	statements depending on the value of the switch
 	expression.
 
-$(GRAMMAR
-$(I SwitchStatement):
-	$(B switch $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+$(SwitchStatement_production)
+$(CaseStatement_production)
+$(V2 $(CaseRangeStatement_production)
+$(FirstExp_production)
+$(LastExp_production)
+)$(DefaultStatement_production)
 
-$(GNAME CaseStatement):
-	$(B case) $(LINK2 expression.html#ArgumentList, $(I ArgumentList)) $(B :) $(PSSEMI_PSCURLYSCOPE)
-
-$(V2 $(GNAME CaseRangeStatement):
-	$(B case) $(I FirstExp) $(B : .. case) $(I LastExp) $(B :) $(PSSEMI_PSCURLYSCOPE)
-
-$(I FirstExp):
-	$(I AssignExpression)
-
-$(I LastExp):
-	$(I AssignExpression)
-)
-$(GNAME DefaultStatement):
-	$(B default :) $(PSSEMI_PSCURLYSCOPE)
-)
-
 	$(P $(EXPRESSION) is evaluated. The result type T must be
 	of integral type or $(CODE char[]), $(CODE wchar[]) or $(CODE dchar[]).
 	The result is
@@ -946,10 +818,7 @@
 $(V2
 <h2>$(LNAME2 FinalSwitchStatement, Final Switch Statement)</h2>
 
-$(GRAMMAR
-$(I FinalSwitchStatement):
-	$(B final switch $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
-)
+$(FinalSwitchStatement_production)
 
 	$(P A final switch statement is just like a switch statement,
 	except that:)
@@ -967,11 +836,7 @@
 
 <h2>$(LNAME2 ContinueStatement, Continue Statement)</h2>
 
-$(GRAMMAR
-$(I ContinueStatement):
-    $(B continue;)
-    $(B continue) $(I Identifier) $(B ;)
-)
+$(ContinueStatement_production)
 
 	A continue aborts the current iteration of its enclosing loop
 	statement, and starts the next iteration.
@@ -1006,11 +871,7 @@
 
 <h2>$(LNAME2 BreakStatement, Break Statement)</h2>
 
-$(GRAMMAR
-$(I BreakStatement):
-    $(B break;)
-    $(B break) $(I Identifier) $(B ;)
-)
+$(BreakStatement_production)
 
 	A break exits the enclosing statement.
 
@@ -1042,11 +903,7 @@
 
 <h2>$(LNAME2 ReturnStatement, Return Statement)</h2>
 
-$(GRAMMAR
-$(I ReturnStatement):
-    $(B return;)
-    $(B return) $(EXPRESSION) $(B ;)
-)
+$(ReturnStatement_production)
 
 	A return exits the current function and supplies its return
 	value.
@@ -1097,13 +954,7 @@
 
 <h2>$(LNAME2 GotoStatement, Goto Statement)</h2>
 
-$(GRAMMAR
-$(I GotoStatement):
-    $(B goto) $(I Identifier) $(B ;)
-    $(B goto) $(B default) $(B ;)
-    $(B goto) $(B case) $(B ;)
-    $(B goto) $(B case) $(EXPRESSION) $(B ;)
-)
+$(GotoStatement_production)
 
 	A goto transfers to the statement labeled with
 	$(I Identifier).
@@ -1157,12 +1008,7 @@
 	The with statement is a way to simplify repeated references
 	to the same object.
 
-$(GRAMMAR
-$(I WithStatement):
-	$(B with) $(B $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
-	$(B with) $(B $(LPAREN)) $(LINK2 template.html#Symbol, $(I Symbol)) $(B $(RPAREN)) $(PSSCOPE)
-	$(B with) $(B $(LPAREN)) $(LINK2 template.html#TemplateInstance, $(I TemplateInstance)) $(B $(RPAREN)) $(PSSCOPE)
-)
+$(WithStatement_production)
 
 	where $(EXPRESSION) evaluates to a class reference or struct
 	instance.
@@ -1241,11 +1087,7 @@
 	a mutex to synchronize access among multiple threads.
 	)
 
-$(GRAMMAR
-$(I SynchronizedStatement):
-    $(B synchronized) $(PSSCOPE)
-    $(B synchronized $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
-)
+$(SynchronizedStatement_production)
 
 	$(P Synchronized allows only one thread at a time to execute
 	$(I ScopeStatement) by using a mutex.
@@ -1282,30 +1124,13 @@
 
 	Exception handling is done with the try-catch-finally statement.
 
-$(GRAMMAR
-$(I TryStatement):
-	$(B try) $(PSSCOPE) $(I Catches)
-	$(B try) $(PSSCOPE) $(I Catches) $(I FinallyStatement)
-	$(B try) $(PSSCOPE) $(I FinallyStatement)
+$(TryStatement_production)
+$(Catches_production)
+$(LastCatch_production)
+$(Catch_production)
+$(CatchParameter_production)
+$(FinallyStatement_production)
 
-$(GNAME Catches):
-	$(I LastCatch)
-	$(I Catch)
-	$(I Catch) $(I Catches)
-
-$(GNAME LastCatch):
-	$(B catch) $(PS0)
-
-$(GNAME Catch):
-	$(B catch $(LPAREN)) $(I CatchParameter) $(B $(RPAREN)) $(PS0)
-
-$(GNAME CatchParameter):
-	$(I BasicType) $(I Identifier)
-
-$(GNAME FinallyStatement):
-	$(B finally) $(PS0)
-)
-
 	$(P $(I CatchParameter) declares a variable v of type T, where T is
 	Object
 	or derived from Object. v is initialized by the throw expression if
@@ -1382,10 +1207,7 @@
 
 	Throw an exception.
 
-$(GRAMMAR
-$(I ThrowStatement):
-	$(B throw) $(EXPRESSION) $(B ;)
-)
+$(ThrowStatement_production)
 
 	$(EXPRESSION) is evaluated and must be an Object reference.
 	The Object reference is thrown as an exception.
@@ -1396,12 +1218,7 @@
 
 <h2>$(LNAME2 ScopeGuardStatement, Scope Guard Statement)</h2>
 
-$(GRAMMAR
-$(I ScopeGuardStatement):
-	$(B scope(exit)) $(PSCURLYSCOPE)
-	$(B scope(success)) $(PSCURLYSCOPE)
-	$(B scope(failure)) $(PSCURLYSCOPE)
-)
+$(ScopeGuardStatement_production)
 
 	The $(I ScopeGuardStatement) executes $(PSCURLYSCOPE) at the close
 	of the current scope, rather than at the point where the
@@ -1492,11 +1309,7 @@
 
 	No code motion occurs across volatile statement boundaries.
 
-$(GRAMMAR
-$(I VolatileStatement):
-	$(B volatile) $(PSSEMI_PSCURLYSCOPE)
-	$(B volatile) $(B ;)
-)
+$(VolatileStatement_production)
 
 	$(PSSEMI_PSCURLYSCOPE) is evaluated.
 	Memory writes occurring before the $(PSSEMI_PSCURLYSCOPE) are
@@ -1513,16 +1326,9 @@
 
 	Inline assembler is supported with the asm statement:
 
-$(GRAMMAR
-$(GNAME AsmStatement):
-	$(B asm { })
-	$(B asm {) $(I AsmInstructionList) $(B })
+$(AsmStatement_production)
+$(AsmInstructionList_production)
 
-$(GNAME AsmInstructionList):
-	$(I AsmInstruction) $(B ;)
-	$(I AsmInstruction) $(B ;) $(I AsmInstructionList)
-)
-
 	An asm statement enables the direct use of assembly language
 	instructions. This makes it easy to obtain direct access to special
 	CPU features without resorting to an external assembler. The
@@ -1594,17 +1400,11 @@
 
 <h2>$(LNAME2 PragmaStatement, Pragma Statement)</h2>
 
-$(GRAMMAR
-$(I PragmaStatement):
-    $(LINK2 pragma.html, $(I Pragma)) $(PSSEMI)
-)
+$(PragmaStatement_production)
 
 <h2>$(LNAME2 MixinStatement, Mixin Statement)</h2>
 
-$(GRAMMAR
-$(I MixinStatement):
-    $(B mixin) $(B $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN)) $(B ;)
-)
+$(MixinStatement_production)
 
 	$(P The $(ASSIGNEXPRESSION) must evaluate at compile time
 	to a constant string.
@@ -1642,17 +1442,10 @@
 
 	A foreach range statement loops over the specified range.
 
-$(GRAMMAR
-$(I ForeachRangeStatement):
-    $(GLINK Foreach) $(LPAREN)$(GLINK ForeachType) $(B ;) $(I LwrExpression) $(B ..) $(I UprExpression) $(B $(RPAREN)) $(PSSCOPE)
+$(ForeachRangeStatement_production)
+$(LwrExpression_production)
+$(UprExpression_production)
 
-$(GNAME LwrExpression):
-    $(EXPRESSION)
-
-$(GNAME UprExpression):
-    $(EXPRESSION)
-)
-
 	$(P
 	$(I ForeachType) declares a variable with either an explicit type,
 	or a type inferred from $(I LwrExpression) and $(I UprExpression).
Index: struct.dd
===================================================================
--- struct.dd	(revision 1638)
+++ struct.dd	(working copy)
@@ -350,45 +350,13 @@
 )
 	)
 
-$(GRAMMAR
-$(GNAME AggregateDeclaration):
-	$(B struct) $(I Identifier) $(I StructBody)
-	$(B union) $(I Identifier) $(I StructBody)
-	$(B struct) $(I Identifier) $(B ;)
-	$(B union) $(I Identifier) $(B ;)
-	$(LINK2 template.html#StructTemplateDeclaration, $(I StructTemplateDeclaration))
-	$(LINK2 template.html#UnionTemplateDeclaration, $(I UnionTemplateDeclaration))
+$(AggregateDeclaration_production)
+$(StructBody_production)
+$(StructBodyDeclarations_production)
+$(StructBodyDeclaration_production)
+$(StructAllocator_production)
+$(StructDeallocator_production)
 
-$(GNAME StructBody):
-	$(B {) $(B })
-	$(B {) $(I StructBodyDeclarations) $(B })
-
-$(GNAME StructBodyDeclarations):
-	$(I StructBodyDeclaration)
-	$(I StructBodyDeclaration) $(I StructBodyDeclarations)
-
-$(GNAME StructBodyDeclaration):
-	$(I Declaration)
-	$(I StaticConstructor)
-	$(I StaticDestructor)
-	$(I Invariant)
-	$(I UnitTest)
-	$(I StructAllocator)
-	$(I StructDeallocator)
-	$(V2 $(GLINK StructConstructor)
-	$(GLINK StructPostblit)
-	$(GLINK StructDestructor))
-$(V2
-	$(LINK2 class.html#AliasThis, $(I AliasThis))
-)
-
-$(GNAME StructAllocator):
-	$(I ClassAllocator)
-
-$(GNAME StructDeallocator):
-	$(I ClassDeallocator)
-)
-
 $(P They work like they do in C, with the following exceptions:)
 
 $(UL
@@ -573,10 +541,7 @@
 $(V2
 $(SECTION3 <a name="Struct-Constructor">Struct Constructors</a>,
 
-$(GRAMMAR
-$(GNAME StructConstructor):
-    $(B this( $(I ParameterList) )) $(I FunctionBody)
-)
+$(StructConstructor_production)
 
 	$(P Struct constructors are used to initialize an instance
 	of a struct.
@@ -590,10 +555,7 @@
 $(V2
 $(SECTION3 <a name="StructPostblit">Struct Postblits</a>,
 
-$(GRAMMAR
-$(GNAME StructPostblit):
-    $(B this(this)) $(I FunctionBody)
-)
+$(StructPostblit_production)
 
 	$(P $(I Copy construction) is defined as initializing
 	 a struct instance from another struct of the same type.
@@ -635,10 +597,7 @@
 $(V2
 $(SECTION3 <a name="StructDestructor">Struct Destructors</a>,
 
-$(GRAMMAR
-$(GNAME StructDestructor):
-    $(B ~this()) $(I FunctionBody)
-)
+$(StructDestructor_production)
 
 	$(P Destructors are called when an object goes out of scope.
 	Their purpose is to free up resources owned by the struct
Index: template-mixin.dd
===================================================================
--- template-mixin.dd	(revision 1638)
+++ template-mixin.dd	(working copy)
@@ -6,21 +6,10 @@
 	the body of a $(I TemplateDeclaration) and inserts them
 	into the current context.
 
-$(GRAMMAR
-$(GNAME TemplateMixinDeclaration):
-	$(V2 $(B mixin)) $(B template) $(TEMPLATEIDENTIFIER) $(B $(LPAREN)) $(TEMPLATEPARAMETERLIST) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt)))
-		$(B {) DeclDefs $(B })
+$(TemplateMixinDeclaration_production)
+$(TemplateMixin_production)
+$(MixinIdentifier_production)
 
-$(GNAME TemplateMixin):
-	$(B mixin) $(TEMPLATEIDENTIFIER) $(B ;)
-	$(B mixin) $(TEMPLATEIDENTIFIER) $(GLINK MixinIdentifier) $(B ;)
-	$(B mixin) $(TEMPLATEIDENTIFIER) $(B !$(LPAREN)) $(TEMPLATEARGUMENTLIST) $(B $(RPAREN)) $(B ;)
-	$(B mixin) $(TEMPLATEIDENTIFIER) $(B !$(LPAREN)) $(TEMPLATEARGUMENTLIST) $(B $(RPAREN)) $(GLINK MixinIdentifier) $(B ;)
-
-$(GNAME MixinIdentifier):
-	$(I Identifier)
-)
-
 	$(P A $(I TemplateMixin) can occur in declaration lists of modules,
 	classes, structs, unions, and as a statement.
 	The $(I TemplateIdentifier) refers to a $(I TemplateDeclaration).
Index: template.dd
===================================================================
--- template.dd	(revision 1638)
+++ template.dd	(working copy)
@@ -10,27 +10,11 @@
 	Templates are defined with a $(I TemplateDeclaration):
 )
 
-$(GRAMMAR
-$(GNAME TemplateDeclaration):
-	$(B template) $(GLINK TemplateIdentifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt)))
-		$(B {) DeclDefs $(B })
+$(TemplateDeclaration_production)
+$(TemplateIdentifier_production)
+$(TemplateParameterList_production)
+$(TemplateParameter_production)
 
-$(GNAME TemplateIdentifier):
-	$(I Identifier)
-
-$(GNAME TemplateParameterList):
-	$(I TemplateParameter)
-	$(I TemplateParameter) , $(I TemplateParameterList)
-
-$(GNAME TemplateParameter):
-	$(GLINK TemplateTypeParameter)
-	$(GLINK TemplateValueParameter)
-	$(GLINK TemplateAliasParameter)
-	$(GLINK TemplateTupleParameter)
-$(V2
-	$(GLINK TemplateThisParameter))
-)
-
 $(P	The body of the $(I TemplateDeclaration) must be syntactically correct
 	even if never instantiated. Semantic analysis is not done until
 	instantiated. A template forms its own scope, and the template
@@ -63,48 +47,13 @@
 	Templates are explicitly instantiated with:
 )
 
-$(GRAMMAR
-$(GNAME TemplateInstance):
-	$(GLINK TemplateIdentifier) $(B !$(LPAREN)) $(GLINK TemplateArgumentList) $(B $(RPAREN))
-$(V2
-	$(GLINK TemplateIdentifier) $(B !) $(GLINK TemplateSingleArgument)
-)
+$(TemplateInstance_production)
+$(TemplateArgumentList_production)
+$(TemplateArgument_production)
+$(Symbol_production)
+$(SymbolTail_production)
+$(V2 $(TemplateSingleArgument_production))
 
-$(GNAME TemplateArgumentList):
-	$(GLINK TemplateArgument)
-	$(GLINK TemplateArgument) , $(I TemplateArgumentList)
-
-$(GNAME TemplateArgument):
-	$(I Type)
-	$(ASSIGNEXPRESSION)
-	$(I Symbol)
-
-$(GNAME Symbol):
-	$(I SymbolTail)
-	$(B .) $(I SymbolTail)
-
-$(GNAME SymbolTail):
-	$(I Identifier)
-	$(I Identifier) $(B .) $(I SymbolTail)
-	$(GLINK TemplateInstance)
-	$(GLINK TemplateInstance) $(B .) $(I SymbolTail)
-
-$(V2
-$(GNAME TemplateSingleArgument):
-	$(I Identifier)
-	$(GLINK2 declaration, BasicTypeX)
-	$(GLINK2 lex, CharacterLiteral)
-	$(GLINK2 lex, StringLiteral)
-	$(GLINK2 lex, IntegerLiteral)
-	$(GLINK2 lex, FloatLiteral)
-	$(B true)
-	$(B false)
-	$(B null)
-	$(B __FILE__)
-	$(B __LINE__)
-)
-)
-
 $(P
 	Once instantiated, the declarations inside the template, called
 	the template members, are in the scope
@@ -324,20 +273,10 @@
 
 <h2>Template Type Parameters</h2>
 
-$(GRAMMAR
-$(GNAME TemplateTypeParameter):
-	$(I Identifier)
-	$(I Identifier) $(I TemplateTypeParameterSpecialization)
-	$(I Identifier) $(I TemplateTypeParameterDefault)
-	$(I Identifier) $(I TemplateTypeParameterSpecialization) $(I TemplateTypeParameterDefault)
+$(TemplateTypeParameter_production)
+$(TemplateTypeParameterSpecialization_production)
+$(TemplateTypeParameterDefault_production)
 
-$(GNAME TemplateTypeParameterSpecialization):
-	 $(B :) $(I Type)
-
-$(GNAME TemplateTypeParameterDefault):
-	 $(B =) $(I Type)
-)
-
 <h3>Specialization</h3>
 
 	$(P Templates may be specialized for particular types of arguments
@@ -370,10 +309,7 @@
 $(V2
 <h2>Template This Parameters</h2>
 
-$(GRAMMAR
-$(GNAME TemplateThisParameter):
-	$(B this) $(I TemplateTypeParameter)
-)
+$(TemplateThisParameter_production)
 
 	$(P $(I TemplateThisParameter)s are used in member function templates
 	to pick up the type of the $(I this) reference.
@@ -410,24 +346,11 @@
 
 <h2>Template Value Parameters</h2>
 
-$(GRAMMAR
-$(GNAME TemplateValueParameter):
-    $(I Declaration)
-    $(I Declaration) $(I TemplateValueParameterSpecialization)
-    $(I Declaration) $(I TemplateValueParameterDefault)
-    $(I Declaration) $(I TemplateValueParameterSpecialization) $(I TemplateValueParameterDefault)
+$(TemplateValueParameter_production)
+$(TemplateValueParameterSpecialization_production)
+$(TemplateValueParameterDefault_production)
 
-$(GNAME TemplateValueParameterSpecialization):
-    $(B :) $(LINK2 expression.html#ConditionalExpression, $(I ConditionalExpression))
-
-$(GNAME TemplateValueParameterDefault):
 $(V2
-    $(B = __FILE__)
-    $(B = __LINE__))
-    $(B =) $(LINK2 expression.html#ConditionalExpression, $(I ConditionalExpression))
-)
-
-$(V2
 	$(P The $(CODE __FILE__) and $(CODE __LINE__) expand to the source
 	file name and line number at the point of instantiation.)
 )
@@ -469,17 +392,10 @@
 
 <h2>$(LNAME2 aliasparameters, Template Alias Parameters)</h2>
 
-$(GRAMMAR
-$(GNAME TemplateAliasParameter):
-    $(B alias) $(I Identifier) $(I TemplateAliasParameterSpecialization)$(SUB $(I opt)) $(I TemplateAliasParameterDefault)$(SUB $(I opt))
+$(TemplateAliasParameter_production)
+$(TemplateAliasParameterSpecialization_production)
+$(TemplateAliasParameterDefault_production)
 
-$(GNAME TemplateAliasParameterSpecialization):
-     $(B :) $(I Type)
-
-$(GNAME TemplateAliasParameterDefault):
-     $(B =) $(I Type)
-)
-
 	$(P Alias parameters enable templates to be parameterized with
 	any type of D symbol, including global names, local names, typedef
 	names, module names, template names, and template instance names.
@@ -614,10 +530,7 @@
 
 <h2>$(LNAME2 variadic-templates, Template Tuple Parameters)</h2>
 
-$(GRAMMAR
-$(GNAME TemplateTupleParameter):
-	$(I Identifier) $(B ...)
-)
+$(TemplateTupleParameter_production)
 
 	$(P If the last template parameter in the $(I TemplateParameterList)
 	is declared as a $(I TemplateTupleParameter),
@@ -779,10 +692,7 @@
 
 <h2>Class Templates</h2>
 
-$(GRAMMAR
-$(GNAME ClassTemplateDeclaration):
-    $(B class) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(I BaseClassList) $(I ClassBody)
-)
+$(ClassTemplateDeclaration_production)
 
 	$(P If a template declares exactly one member, and that member is a class
 	with the same name as the template:
@@ -811,17 +721,10 @@
 
 <h2>Struct, Union, and Interface Templates</h2>
 
-$(GRAMMAR
-$(GNAME StructTemplateDeclaration):
-    $(B struct) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 struct.html#StructBody, $(I StructBody))
+$(StructTemplateDeclaration_production)
+$(UnionTemplateDeclaration_production)
+$(InterfaceTemplateDeclaration_production)
 
-$(GNAME UnionTemplateDeclaration):
-    $(B union) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 struct.html#StructBody, $(I StructBody))
-
-$(GNAME InterfaceTemplateDeclaration):
-    $(B interface) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 interface.html#BaseInterfaceList, $(I BaseInterfaceList)) $(LINK2 interface.html#InterfaceBody, $(I InterfaceBody))
-)
-
 	$(P Analogously to class templates, struct, union and interfaces
 	can be transformed into templates by supplying a template parameter list.
 	)
Index: traits.dd
===================================================================
--- traits.dd	(revision 1638)
+++ traits.dd	(working copy)
@@ -11,47 +11,11 @@
 	as required.
 	)
 
-$(GRAMMAR
-$(GNAME TraitsExpression):
-    $(B __traits) $(B $(LPAREN)) $(I TraitsKeyword) $(B ,) $(I TraitsArguments) $(B $(RPAREN))
+$(TraitsExpression_production)
+$(TraitsKeyword_production)
+$(TraitsArguments_production)
+$(TraitsArgument_production)
 
-$(GNAME TraitsKeyword):
-    $(B isAbstractClass)
-    $(B isArithmetic)
-    $(B isAssociativeArray)
-    $(B isFinalClass)
-    $(B isFloating)
-    $(B isIntegral)
-    $(B isScalar)
-    $(B isStaticArray)
-    $(B isUnsigned)
-    $(B isVirtualFunction)
-    $(B isAbstractFunction)
-    $(B isFinalFunction)
-$(V2      $(GBLINK isStaticFunction)
-)    $(GBLINK isRef)
-    $(GBLINK isOut)
-    $(GBLINK isLazy)
-    $(B hasMember)
-$(V2      $(GBLINK identifier)
-)    $(B getMember)
-$(V2      $(GBLINK getOverloads)
-)    $(GBLINK getVirtualFunctions)
-    $(B classInstanceSize)
-    $(GBLINK allMembers)
-    $(GBLINK derivedMembers)
-    $(B isSame)
-    $(B compiles)
-
-$(GNAME TraitsArguments):
-    $(I TraitsArgument)
-    $(I TraitsArgument) $(B ,) $(I TraitsArguments)
-
-$(GNAME TraitsArgument):
-    $(I AssignExpression)
-    $(I Type)
-)
-
 $(H2 isArithmetic)
 
 	$(P If the arguments are all either types that are arithmetic types,
Index: unittest.dd
===================================================================
--- unittest.dd	(revision 1638)
+++ unittest.dd	(working copy)
@@ -2,10 +2,7 @@
 
 $(SPEC_S $(TITLE),
 
-$(GRAMMAR
-$(GNAME UnitTest):
-	$(B unittest) $(I FunctionBody)
-)
+$(UnitTest_production)
 
 	$(P Unit tests are a series of test cases applied to a module to determine
 	if it is working properly. Ideally, unit tests should be run every
